
1K DISASSEMBLER
by H.M. Tucker
from ZX Computing Jun/Jul.1984

Part 1. Print address (bytes 1 to 29).

ADDRESS  MNEMONIC      CODE         REMARKS

4082     4xNOP         00 00 00 00  Watch this space
86       LD B,2        06 02        Counter for two byte address
88       XOR A         AF           Clear accumulator
89       LD HL,407C    21 7C 40     Address of hi byte of start
8C       RRD (HL)      ED 67        Move nibbles
8E       LD E,A        5F           Save lo nibble
8F       LD D,(HL)     56           Hi nibble into accumulator,
                                    avoiding code 7E.
90       LD A,D        7A
91       ADD A,1C      C6 1C        Convert
93       RST 10        D7           Print hi nibble
94       LD A,E        7B           Lo nibble into accumulator
95       ADD A,1C      C6 1C        Convert
97       RST 10        D7           Print lo nibble
98       SUB A,1C      D6 1C        Restore the byte in (HL)
9A       RLD,(HL)      ED 6F
9C       DEC,HL        2B           Address of lo byte of start
9D       DJNZ,ED       10 ED        Jump to 408C


Part 2. MOVE DATA (bytes 30 to 40).

9F       LD BC,4       01 04 00     Byte counter
A2       LD DE,4082    11 82 40     Destination, is the reserved space
A5       LD HL,(407B)  2A 7B 40     Source, is start, or updated address
A8       LDIR          ED B0        Move it


Part 3. SEARCH (bytes 41 to 186).

40AA     LD A,(4082)   3A 82 40     Load accumulator with byte one
AD       LD HL,40D1    21 D1 40     Pointer to Table 1
B0       LD C,3        0E 03        Length of Table 1
B2       CPIR          ED B1        Look for match
B4       JRZ,54        28 54        Jump to 410A if found, to look at byte two
40B6     LD C,1A       0E 1A        Length of Table 2
B8       CPIR          ED B1        Look for match (two byte instruction)
BA       JRZ,9         28 09        Jump to 40C5 if found
BC       LD C,1C       0E 1C        Length of Table 3
BE       CPIR          ED B1        Look for match (three byte instruction)
C0       JRZ,7         28 07        Jump to 40C9 if found
C2       INC C         0C           Must be a one byte instruction
C3       JR,77         18 77        GOTO Part 4 - print code
40C5     LD C,2        0E 02        Two byte instruction
C7       JR,73         18 73        GOTO Part 4 - print code
40C9     LD C,3        0E 03        Three byte instruction
CB       JR,6F         18 6F        GOTO Part 4 - print code
40CD     LD C,4        0E 04        Four byte instruction
CF       JR,6B         18 6B        GOTO Part 4 - print code
         Table 1                    Begins at byte 80
40D1                   DD ED FD
         Table 2                    Begins at byte 83
                       06 0E 10 16 18 1E 20 26 28 2E 30 36 38
                     * 3E C6 CB CE D3 D6 DB DE E6 ED EE F6 FE
         Table 3                    Begins at byte 109
                     * 01 11 21 22 2A 31 32 3A C2 C3 C4 CA CC CD
                       D2 D4 DA DC DD E2 E4 EA EC F2 F4 FA FC FD

[The lines marked "*" were transposed in the magazine, thus some of the     ]
[2-byte instructions were treated as 3-byte instructions, & vice versa. JimG]

410A     LD A,(4083)   3A 83 40     Load accumulator with byte two
0D       LD HL,4124    21 24 41     Pointer to Table 4
10       LD C,0D       0E 0D        Length of Table 4
12       CPIR          ED B1        Look for match
14       JRZ,B7        28 B7        Jump to 40CD if found
16       LD C,0B       0E 0B        Length of Table 2A
18       CPIR          ED B1        Look for match
1A       JRZ,A9        28 A9        Jump to 40C5 if found
1C       LD A,(4082)   3A 82 40     Load accumulator with byte one
1F       LD HL,40D4    21 D4 40     Pointer to Table 2
22       JR,92         18 92        Rejoin mainstream at 40B6
         Table 4                    Begins at byte 163
4124                   21 22 2A 36 43 4B 53 5B 63 6B 73 7B CB
         Table 2A                   Begins at byte 176
                       09 19 23 29 2B 39 E1 E3 E5 E9 F9


Part 4. PRINT CODE (bytes 187 to 208).

413C     LD B,C        41           Load B with number of bytes
3D       LD HL,4082    21 82 40     Point HL at first byte
40       XOR A         AF           Clear accumulator
41       RST 10        D7           Print space
42       RRD,(HL)      ED 67        Rotate nibbles
44       LD E,A        5F           Save lo nibble
45       LD D,(HL)     56           Hi nibble into accumulator
46       LD A,D        7A           Avoiding code 7E
47       ADD A,1C      C6 1C        Convert
49       RST 10        D7           Print hi nibble
4A       LD A,E        7B           Lo nibble into accumulator
4B       ADD A,1C      C6 1C        Convert
4D       RST 10        D7           Print lo nibble
4E       INC HL        23           Next byte
4F       DJNZ,EF       10 EF        Until B is zero
4151     RET           C9           Return to BASIC


--
Another Fine Product transcribed by:
Jim Grimwood (jimg@globalnet.co.uk), Weardale, England
--
